#include "Stoplight.h"
#include "wiring.h"

Stoplight::Stoplight(int RedBulb, int GreenBulb, int YellowBulb) {
  this->redBulb    = RedBulb ;
  this->greenBulb  = GreenBulb ;
  this->yellowBulb = YellowBulb ;
  pinMode(RedBulb, OUTPUT) ;
  pinMode(GreenBulb, OUTPUT) ;
  pinMode(YellowBulb, OUTPUT) ;
}

int Stoplight::GetRedBulb() {
  return redBulb ;
}

int Stoplight::GetGreenBulb() {
  return greenBulb ;
}

int Stoplight::GetYellowBulb() {
  return yellowBulb ;
}

static int int2lowhigh(int v) {
  return v ? HIGH : LOW ; 
}

void Stoplight::SetRedLight(int newRed) {
  digitalWrite(redBulb, int2lowhigh(newRed)) ; 
}

void Stoplight::SetYellowLight(int newYellow) {
  digitalWrite(yellowBulb, int2lowhigh(newYellow)) ;
}

void Stoplight::SetGreenLight(int newGreen) {
  digitalWrite(greenBulb, int2lowhigh(newGreen)) ;
}

int Stoplight::GetRedLight() {
  return digitalRead(redBulb) == HIGH ? 1 : 0 ;
}

int Stoplight::GetYellowLight() {
  return digitalRead(yellowBulb) == HIGH ? 1 : 0 ;
}

int Stoplight::GetGreenLight() {
  return digitalRead(greenBulb) == HIGH ? 1 : 0 ;
}

